// Exercise 9.6 p. 387

var x, y, z, k: int;

function exp(x: int, y: int) returns (z: int);
axiom (forall x: int :: exp(x,0) == 1);
axiom (forall x: int, y: int :: exp(x,y) == mult(x,exp(x,y-1)));

// For good old multiplication in the logic.
function mult(x: int, y: int) returns (z: int);
// Multiplication is associative.
axiom (forall x: int, y: int, z: int :: mult(x, mult(y, z)) == mult(mult(x, y), z));

// Instead of using *, we'll use times:
procedure times(x: int, y: int) returns (z: int);
        ensures z == mult(x,y);
        
// For integer division in the logic.
function div(x: int, y: int) returns (z: int);

// Instead of using /, we'll use divide:
procedure divide(x: int, y: int) returns (z: int);
        ensures z == div(x, y);
        
// A predicate for the logic expressing that a number is even.
function even(x: int) returns (b: bool);

// A relationship between even, exp, mult and div:
axiom (forall x: int, y: int :: even(y) ==> (exp(mult(x,x),div(y,2)) == exp(x,y)));

procedure exercise_9_6_3()
        requires even(y) && mult(z, exp(x,y)) == k;
        ensures mult(z, exp(x,y)) == k;
        modifies x,y;
{
        call y := divide(y, 2);
        call x := times(x, x);
}